<?php
namespace PlaySms\PlaySms\Controller\Adminhtml\Config;
use Magento\Backend\App\Action;

class Edit extends \Magento\Backend\App\Action
{
    public function execute()
    {
        $data = $this->getRequest()->getPostValue("config");
        if(!empty($data)){
            
            if ($this->validateApiKey($data['api_key'])){
            
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();       
                $question = $objectManager->create('PlaySms\PlaySms\Model\Config');
                $question->setData($data);
                $question->save();
                
                $this->messageManager->addSuccess( __('Zapisano zmiany.') );
            
            }else{
                
                $this->messageManager->addError( __('Błędny klucz API. Spróbuj ponownie.') );
                
            }
            
            $this->_redirect('*/index');
            return;
        }
        
        $this->_view->loadLayout();
        $this->_view->renderLayout();
    }
    
    private function validateApiKey($apiKey){
        if (!empty($apiKey) && preg_match("/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i", $apiKey)){
            return true;
        }else{
            return false;
        }
    }
}