<?php
namespace PlaySms\PlaySms\Controller\Adminhtml\Events;
use Magento\Backend\App\Action;

class Edit extends \Magento\Backend\App\Action
{
    public function execute()
    {
        $params = $this->getRequest()->getParams();
        $data = $this->getRequest()->getPostValue("events");
        
        if(isset($params['isAjax'])){
            die;
        }
        
        if(!empty($data)){
            
            if ($this->validateName($data['name']) && $this->validateActionType($data['action_type']) && $this->validateSender($data['sender']) && $this->validateSmsContent($data['sms_content'])){
                
                if($data['clear_polish'] == 'yes'){
                    $maxChars = 6*160;
                } else {
                    $maxChars = 6*70;
                }

                if(mb_strlen($data['sms_content']) > $maxChars){
                    $this->messageManager->addError( __('Treść SMS ma za dużą liczbę znaków!') );
                    $this->_redirect('*/events/edit/id/'.$data['id']);
                    return;
                }

                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();       
                $question = $objectManager->create('PlaySms\PlaySms\Model\Events');
                $question->setData($data);
                $question->save();

                $this->messageManager->addSuccess( __('Zapisano zmiany.') );
                
                $resultRedirect = $this->resultRedirectFactory->create(); 
                return $resultRedirect->setPath('*/events');
            
            }else{
                $resultRedirect = $this->resultRedirectFactory->create(); 
                return $resultRedirect->setPath('*/events/edit/id/'.$data['id']);
            }
            
        }
        
        $this->_view->loadLayout();
        $this->_view->renderLayout();
    }
    
    private function validateName($name){
        
        if (!empty($name) && strlen($name) >= 3){
            return true;
        }else{
            $this->messageManager->addError( __('Błąd. Nazwa eventu powinna mieć co najmniej 3 znaki.') );
            return false;
        }
    }
    
    private function validateActionType($actionType){
        
        if (!empty($actionType)){
            return true;
        }else{
            $this->messageManager->addError( __('Błąd. Wskazany typ eventu nie jest obsługiwany. Prosimy o kontakt w celu wyjaśnienia tego problemu - PlaySMS.pl.') );
            return false;
        }
    }
    
    private function validateSender($sender){
        
        if (!empty($sender) && strlen($sender) >= 3){
            return true;
        }else{
            $this->messageManager->addError( __('Błąd. Pole nadawcy powinno mieć co najmniej 3 znaki.') );
            return false;
        }
    }
    
    private function validateSmsContent($smsContent){
        
        if (!empty($smsContent) && strlen($smsContent) >= 3){
            return true;
        }else{
            $this->messageManager->addError( __('Błąd. Treść SMS powinna mieć co najmniej 3 znaki.') );
            return false;
        }
    }
}