<?php
namespace PlaySms\PlaySms\Model\Config\Source;

use PlaySms\PlaySms\PlaySmsVendor\SenderFields;

class DefaultSenders implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @return array
     */
    public function toOptionArray()
    {
        $this->_resources = \Magento\Framework\App\ObjectManager::getInstance()
                ->get('Magento\Framework\App\ResourceConnection');
        $connection= $this->_resources->getConnection();

        $select = $connection->select()
            ->from(
                ['o' =>  $this->_resources->getTableName('playsms_playsms_config')]
            );

        $result = $connection->fetchAll($select);
        
        if (isset($result[0]['api_key']) && isset($result[0]['password'])){
            $smsApiKey = $result[0]['api_key'];
            $smsPassword = $result[0]['password'];
        }else{
            $smsApiKey = '';
            $smsPassword = '';
        }
        
        if($smsApiKey == 'klucz_api'){
            return [['value' => 'Informacja', 'label' => 'Podaj klucz API, by uzupełnić listę nadawców']];
        }
        
        $senderFieldsObj = new SenderFields($smsApiKey, $smsPassword);
        $senderFieldsJson = $senderFieldsObj->getHeaders();
        
        if ($senderFieldsJson !== 'ERROR'){
            $senderFieldsArr = json_decode($senderFieldsJson);

            $return = [];
            foreach($senderFieldsArr as $sender){
                $return[] = ['value' => $sender, 'label' => $sender];
            }
        
        }else{
            $return[] = ['value' => 'WYBIERZ DOMYŚLNEGO NADAWCĘ', 'label' => __('Błędne dane do API')];
        }
        
        return $return;
    }
}
 
?>