<?php

namespace PlaySms\PlaySms\PlaySmsVendor;

if (!class_exists('SendSms')){
    
    class SendSms {

            public $apiUserName;
            public $apiPassword;
            public $to = null;
            public $message = null;
            public $format = 'json';
            public $header = null;
            public $clearPolish;
            public $test = 1;

            public function __construct( $apiUserName, $apiPassword, $to, $message, $test, $header, $clearPolish) {
                    $this->setTo( $to );
                    $this->setMessage( $message );
                    $this->setApiUserName( $apiUserName );
                    $this->setApiPassword( $apiPassword );
                    $this->setTest( $test );
                    $this->setHeader( $header );
                    $this->clearPolish( $clearPolish );
            }

            public function setApiUserName( $apiUserName ) {
                    $this->apiUserName = $apiUserName;
            }

            public function setHeader( $header ) {
                    if ( $header !== null ) {
                            $this->header = $header;
                    }
            }

            public function setApiPassword( $apiPassword ) {
                    $this->apiPassword = $apiPassword;
            }

            public function setResponseFormat( $format ) {
                    $this->format = $format;
            }

            public function setTo( $to ) {
                    $this->to = $to;
            }

            public function setMessage( $message ) {
                    $this->message = $message;
            }

            public function setTest( $test ) {
                    $this->test = $test;
            }

            public function clearPolish( $clearPolish ) {

                if ($clearPolish === 'yes'){
                    $clearPolish = 1;
                }else{
                    $clearPolish = 0;
                }

                    $this->clearPolish = $clearPolish;
            }

            public function send() {
                    $newsXML        = new \SimpleXMLElement( "<?xml version=\"1.0\" encoding=\"UTF-8\"?><data/>" );
                    $key            = $newsXML->addChild( 'key', $this->apiUserName );
                    $password       = $newsXML->addChild( 'password', $this->apiPassword );
                    $sms            = $newsXML->addChild( 'sms' );
                    $responseFormat = $sms->addChild( 'format', $this->format );
                    $msg            = $sms->addChild( 'msg', $this->message );
                    $header         = $sms->addChild( 'from', $this->header );
                    $to             = $sms->addChild( 'to', $this->to );
                    $clear_polish   = $sms->addChild( 'clear_polish', $this->clearPolish );
                    $test           = $sms->addChild( 'test', $this->test );

                    $xmlObjectToString = (string) $newsXML->asXML();


                    $xmlData = "xmldata=" . $xmlObjectToString . "";

                    $url = 'https://api.playsms.pl';

                    $c = curl_init();
                    curl_setopt( $c, CURLOPT_URL, $url );
                    curl_setopt( $c, CURLOPT_HEADER, false );
                    curl_setopt( $c, CURLOPT_POST, true );
                    curl_setopt( $c, CURLOPT_POSTFIELDS, $xmlData );
                    curl_setopt( $c, CURLOPT_RETURNTRANSFER, true );

                    $content = curl_exec( $c );

                    curl_close( $c );


                    return $content;
            }
    }

}