<?php
namespace PlaySms\PlaySms\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;

class UpgradeSchema implements UpgradeSchemaInterface
{
    public function upgrade( SchemaSetupInterface $setup, ModuleContextInterface $context )
    {
        $installer = $setup;
        $installer->startSetup();
        if(version_compare($context->getVersion(), '1.2.0') >= 0) {
            if (!$installer->tableExists('playsms_playsms_config')) {
                $table = $installer->getConnection()->newTable(
                    $installer->getTable('playsms_playsms_config')
                )
                ->addColumn(
                    'id',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'identity' => true,
                        'nullable' => false,
                        'primary'  => true,
                        'unsigned' => true,
                    ],
                    'id'
                )
                ->addColumn(
                    'api_key',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    255,
                    ['nullable => false'],
                    'API key'
                )
                ->addColumn(
                    'password',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    255,
                    [],
                    'password'
                )
                ->addColumn(
                    'default_sender',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    255,
                    [],
                    'Default sender'
                )
                ->setComment('Config table');

                $installer->getConnection()->createTable($table);
            }
            
            if (!$installer->tableExists('playsms_playsms_events')) {
                $table = $installer->getConnection()->newTable(
                    $installer->getTable('playsms_playsms_events')
                )
                    ->addColumn(
                        'id',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        null,
                        [
                            'identity' => true,
                            'nullable' => false,
                            'primary'  => true,
                            'unsigned' => true,
                        ],
                        'ID'
                    )
                    ->addColumn(
                        'name',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        255,
                        [],
                        'Event name'
                    )
                    ->addColumn(
                        'action_type',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        255,
                        [],
                        'Hook'
                    )
                    ->addColumn(
                        'sms_content',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        960,
                        [],
                        'SMS content'
                    )
                    ->addColumn(
                        'sender',
                        \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                        255,
                        [],
                        'Sender'
                    )
                    ->addColumn(
                        'clear_polish',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        255,
                        [],
                        'Clear polish chars'
                    )
                    ->setComment('Events table');

                $installer->getConnection()->createTable($table);
            }
            
            if (!$installer->tableExists('playsms_playsms_greeted_users')) {
                $table = $installer->getConnection()->newTable(
                    $installer->getTable('playsms_playsms_greeted_users')
                )
                    ->addColumn(
                        'id',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        null,
                        [
                            'identity' => true,
                            'nullable' => false,
                            'primary'  => true,
                            'unsigned' => true,
                        ],
                        'ID'
                    )
                    ->addColumn(
                        'customer_id',
                        \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                        255,
                        [],
                        'Customer ID'
                    )
                    ->setComment('Greeted users table');

                $installer->getConnection()->createTable($table);
            }
            
            if (!$installer->tableExists('playsms_playsms_sms_errors')) {
                $table = $installer->getConnection()->newTable(
                    $installer->getTable('playsms_playsms_sms_errors')
                )
                ->addColumn(
                    'id',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'identity' => true,
                        'nullable' => false,
                        'primary'  => true,
                        'unsigned' => true,
                    ],
                    'id'
                )
                ->addColumn(
                    'date',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    255,
                    ['nullable => false'],
                    'Error time'
                )
                ->addColumn(
                    'description',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    500,
                    [],
                    'Error description'
                )
                ->addColumn(
                    'action',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    255,
                    [],
                    'Action when error occured'
                )
                ->setComment('Sms errors table');

                $installer->getConnection()->createTable($table);
            }
            
        }
        $installer->endSetup();
    }
}
