<?php

namespace PlaySms\PlaySms\Ui\Component\Listing\Column;

use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;
use Magento\Framework\UrlInterface;

/**
 * Class DepartmentActions
 */
class EventsActions extends Column
{
    /**
     * @var UrlInterface
     */
    protected $urlBuilder;

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param UrlInterface $urlBuilder
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        UrlInterface $urlBuilder,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */
    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                $item['action_type'] = str_replace('new_account', 'Nowe konto', $item['action_type']);
                $item['action_type'] = str_replace('new_order', 'Nowe zamówienie', $item['action_type']);
                $item['action_type'] = str_replace('change_order_status_to_', 'Zmiana statusu zamówienia na ', $item['action_type']);
                $item[$this->getData('name')]['edit'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'playsms/events/edit',
                        ['id' => $item['id']]
                    ),
                    'label' => __('Edytuj'),
                    'hidden' => false,
                ];
                $item[$this->getData('name')]['delete'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'playsms/events/delete',
                        ['id' => $item['id']]
                    ),
                    'label' => __('Usuń'),
                    'confirm' => [
                        'title' => __('Usuwanie rekordu.'),
                        'message' => __('Czy na pewno chcesz skasować ten rekord?')
                    ],
                    'hidden' => false,
                ];
            }
        }

        return $dataSource;
    }
}