require(['jquery'], function() {
    
    jQuery(document).ready(function(){
        jQuery('.playSMS-addVariableToMessage').hide();

        text_max = 70;
        form_ok = true;

        jQuery('.playSMS-addVariableToMessage').show();

        jQuery('#playSMS-countMessage').html("<p>Zostało " + text_max + " znaków</p>");
    });
    
    jQuery('.entry-edit').one('change', function(){
        setTimeout(function(){
            jQuery('textarea[name="events[sms_content]"]').keyup();
            jQuery('textarea[name="events[sms_content]"]').paste();
        }, 1500);
    });

    jQuery('.entry-edit').on('click', 'select[name="events[clear_polish]"]', function () {
        var eventMessageID, messageCounterID;
        
        eventMessageID = 'textarea[name="events[sms_content]"]';
        messageCounterID = '#playSMS-countMessage';

        var textAreaCount = jQuery(eventMessageID).val().length;
        var textAreaValue = jQuery(eventMessageID).val();

        var $remaining = jQuery(messageCounterID),
            $messages = $remaining.next();
            
        if (jQuery(this).val() == 'yes') {
            changeSpecialCharactersToNormalCharacters(textAreaValue);
            text_max = 160;
        } else {
            text_max = 70;
        }

        var chars = this.value.length,
            messages = Math.ceil(textAreaCount / text_max),
            remaining = messages * text_max - (textAreaCount % (messages * text_max) || messages * text_max);

        if (messages > 6) {
            $remaining.html("<p>Wykorzystano limit znaków.</p>");
            jQuery('#save').hide();
            form_ok = false;
        } else {
            $remaining.html("<p>Liczba wiadomości SMS: " + messages + "<br>Zostało " + remaining + " znaków</p>");
            form_ok = true;
            jQuery('#save').show();
        }

        if (textAreaCount === 0 && messages === 0) {
            if (jQuery(this).val() == 'yes') {
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 160 znaków</p>");
            } else {
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 70 znaków</p>");
            }
        }
    });

    jQuery('.entry-edit').on('keyup paste', 'textarea[name="events[sms_content]"]', function () {

        var checkbox, messageCounter;

        var textAreaValue = jQuery(this).val();
        checkbox = 'select[name="events[clear_polish]"]';
        messageCounter = '#playSMS-countMessage';

        if(jQuery(checkbox).val() == 'yes'){
            changeSpecialCharactersToNormalCharacters(textAreaValue);
        }

        var $remaining = jQuery(messageCounter),
            $messages = $remaining.next();
        var chars = this.value.length,
            messages = Math.ceil(chars / text_max),
            remaining = messages * text_max - (chars % (messages * text_max) || messages * text_max);

        if (messages > 6) {
            $remaining.html("<p>Wykorzystano limit znaków.</p>");
            jQuery('#save').hide();
        } else {
            $remaining.html("<p>Liczba wiadomości SMS: " + messages + "<br>Zostało " + remaining + " znaków</p>");
            jQuery('#save').show();
        }

        if (chars === 0 && messages === 0) {
            if(jQuery(checkbox).val() == '1'){
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 160 znaków</p>");
            } else {
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 70 znaków</p>");
            }
        }
    });

    function changeSpecialCharactersToNormalCharacters(textareaValue, elementID) {
        var polishSpecialChars = {};
        polishSpecialChars['ą'] = 'a';
        polishSpecialChars['Ą'] = 'A';
        polishSpecialChars['ć'] = 'c';
        polishSpecialChars['Ć'] = 'C';
        polishSpecialChars['ę'] = 'e';
        polishSpecialChars['Ę'] = 'E';
        polishSpecialChars['ł'] = 'l';
        polishSpecialChars['Ł'] = 'L';
        polishSpecialChars['ń'] = 'n';
        polishSpecialChars['Ń'] = 'N';
        polishSpecialChars['ó'] = 'o';
        polishSpecialChars['Ó'] = 'O';
        polishSpecialChars['ś'] = 's';
        polishSpecialChars['Ś'] = 'S';
        polishSpecialChars['ź'] = 'z';
        polishSpecialChars['Ź'] = 'Z';
        polishSpecialChars['ż'] = 'z';
        polishSpecialChars['Ż'] = 'Z';
        var textAreaNewValue = '';

        var eventMessageID = 'textarea[name="events[sms_content]"]';

        if (/^[a-zA-Z0-9- {}]*$/.test(textareaValue) === false) {
            jQuery.each(polishSpecialChars, function (key, value) {
                if (jQuery.isNumeric(elementID)) {
                    textAreaNewValue = jQuery(eventMessageID + elementID).val();
                    if (textAreaNewValue.indexOf(key) >= 0) {
                        var regex = new RegExp(key, 'igm');
                        var newMessage = textAreaNewValue.replace(regex, value);
                        jQuery(eventMessageID + elementID).val(newMessage);
                        
                        jQuery(eventMessageID + elementID).trigger("change");
                    }
                } else {
                    textAreaNewValue = jQuery(eventMessageID).val();
                    if (textAreaNewValue.indexOf(key) >= 0) {
                        var regex = new RegExp(key, 'igm');
                        var newMessage = textAreaNewValue.replace(regex, value);
                        jQuery(eventMessageID).val(newMessage);
                        
                        jQuery(eventMessageID).trigger("change");
                    }
                }
            });
        }
        
    }

    /**
    * Save caret position on loosing focus and add variable in message at the saved caret position
    */
    var caretStart, caretEnd;

    jQuery(document).on('blur', 'textarea[name="events[sms_content]"]', function (e) {
        caretStart = this.selectionStart;
        caretEnd = this.selectionEnd;
    });

    jQuery(document).on('click', '.playSMS-addVariableToMessage', function (event) {
        var textareaID;

        textareaID = 'textarea[name="events[sms_content]"]';

        jQuery(textareaID).focus();
        var textToAdd = "{{" + jQuery(this).val() + "}} ";
        var eventsTextareaMessage = jQuery(textareaID);

        if (caretStart === undefined){
            var count = jQuery(textareaID).val().length;

            caretStart = count;
            caretEnd = count;
        }

        // set text area value to: text before caret + desired text + text after caret
        eventsTextareaMessage.val(eventsTextareaMessage.val().substring(0, caretStart)
            + textToAdd
            + eventsTextareaMessage.val().substring(caretEnd));

        // put caret at right position again
        eventsTextareaMessage.selectionStart = eventsTextareaMessage.selectionEnd = caretStart + textToAdd.length;
        jQuery(textareaID).keyup();

        jQuery(textareaID).trigger("change");
    });

    (function ($, undefined) {
        $.fn.getCursorPosition = function () {
            var el = $(this).get(0);
            var pos = 0;
            if ('selectionStart' in el) {
                pos = el.selectionStart;
            } else if ('selection' in document) {
                el.focus();
                var Sel = document.selection.createRange();
                var SelLength = document.selection.createRange().text.length;
                Sel.moveStart('character', -el.value.length);
                pos = Sel.text.length - SelLength;
            }
            return pos;
        };
    })(jQuery);
        
});


